##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (Open-CD-DVD)	= PkgName
# sampledir (ksm-open-cd-dvd)	= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (cd-dvd)		= config file name (no extension)
# sampledm (sampledm)		= the daemon (rc-script, rc-link, systemd.service)
# sample (sample)		= all others
##############################################################################

# Specfile for Open-CD-DVD

%define name	ksm-open-cd-dvd
%define version	1.0.4
%define release	3.1.0
%define _arch	noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _sysddir	/etc/systemd/system
%define _bindir		/usr/local/bin
%define _sbindir	/usr/local/sbin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _libdir		/usr/local/lib/sh
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	Programs to produce CDs/DVDs
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Multimedia/CD/Record
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	samplepkg,samplecapab
Requires:	genisoimage,icedax,wodim,cdrkit-cdrtools-compat
Requires:	cdrdao,dvd+rw-tools,perl-CDDB_get
Requires:	ksm-lib-sh >= 4.0.0-0.0.0,ksm-multimedia >= 1.0.6-4.0.0
Provides:	libfunccddvd-sh
Conflicts:	ksm-open-cd-dvd-new
#Obsoletes:	mysampledm

%description
This Package provides the following programs to copy, create, rip and burn 
CDs/DVDs:

cd2mp3, cddacopy, makecd, makedvd, ripcdda2wav, scandisc

It installs the global config file /usr/local/etc/cd-dvd.conf and the 
library libfunccddvd-sh

Please check/configure:
 /usr/local/etc/cd-dvd.conf

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/cd-dvd.conf
#%config %{_confdir}/cd-dvd.conf
#%config %{_scnfdir}/cd-dvd
#%attr(644,root,root)%{_confdir}/cd-dvd.conf
%attr(644,root,root)%{_confdir}/cd-dvd.conf
#%attr(644,root,root)%{_scnfdir}/cd-dvd

#%attr(744,root,root)%{_rcdir}/sampledm
#%attr(777,root,root)%{_sbindir}/rcsampledm
#%attr(744,root,root)%{_sbindir}/sampledm.sh

%attr(755,root,root)%{_bindir}/cd2mp3
%attr(755,root,root)%{_bindir}/cddacopy
%attr(755,root,root)%{_bindir}/makecd
%attr(755,root,root)%{_bindir}/makedvd
%attr(755,root,root)%{_bindir}/ripcdda2wav
%attr(755,root,root)%{_bindir}/scandisc
/usr/local/lib/sh/libfunccddvd-sh-%{version}

%{_datadir}/RELEASE
%{_datadir}/VERSION
%{_datadir}/bash.bashrc.local.add
#%attr(744,root,root)%{_datadir}/sampledm.rc
#%{_datadir}/sampledm.service

#/usr/share/applications/sample.desktop

#%{_icondir}/16x16/apps/sample.png
#%{_icondir}/22x22/apps/sample.png
#%{_icondir}/32x32/apps/sample.png
#%{_icondir}/48x48/apps/sample.png
#%{_icondir}/64x64/apps/sample.png
#%{_icondir}/128x128/apps/sample.png
#/usr/share/pixmaps/sample.png

%docdir %{_man1dir}
%{_man1dir}/cd2mp3.1.gz
%{_man1dir}/cddacopy.1.gz
%{_man1dir}/makecd.1.gz
%{_man1dir}/makedvd.1.gz
%{_man1dir}/ripcdda2wav.1.gz
%{_man1dir}/scandisc.1.gz

#%docdir %{_man8dir}
#%{_man8dir}/sample.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
#%{_docdir}/README.de

#---------------------- ORDER OF SCRIPTLETS ----------------------------------
# O=old pkg, N=new pkg

# INSTALL:
# 1. Run %pre section of N		(Arg is 1)
# 2. Install files from N
# 3. Run %post section of N		(Arg is 1)

# UNINSTALL:
# 1. Run %preun section of O		(Arg is 0)
# 2. Delete files from O
# 3. Run %postun section of O		(Arg is 0)

# UPGRADE:
#  1. Run %pre section of O		(Arg is 2)
#  2. Install files from N
#  3. Run %post section of N		(Arg is 2)
#  4. Execute install. triggers (%triggerin in other pkgs) set off by install N
#  5. Execute installation triggers of N
#  6. Execute uninstallation triggers (%triggerun) of O
#  7. Execute uninstallation triggers (of other pkgs) set off by uninstall O
#  8. Run %preun section of O		(Arg is 1)
#  9. Delete files from O not contained in N
# 10. Run %postun section of O		(Arg is 1)

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# check on mkisofs or genisoimage

# backup config files
test -e %{_confdir}/cd-dvd.conf && cp %{_confdir}/cd-dvd.conf %{_confdir}/cd-dvd.conf.rpmsave
#test -e %{_scnfdir}/cd-dvd && cp %{_scnfdir}/cd-dvd %{_scnfdir}/cd-dvd.rpmsave

# disable sample daemon and stop sampledm
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
#test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
rm -f %{_libdir}/libfunccddvd-sh

# uninstall desktop files
#xdg-desktop-menu uninstall \
#	/usr/share/applications/sample.directory \
#	/usr/share/applications/sample.desktop \
#	/usr/share/applications/sample-admin.desktop

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# set config pathname and all config vars from new config file
cf=%{_confdir}/cd-dvd.conf
cnfvars='READER WRITER SpeedCR SpeedCW SpeedDR SpeedDW SpeedD9 FiFoS DrvRTim CDBase CDImage CDMaster AudioPre AudioImage CDToc'

c='' s='' t='' cnt=0 i=0 ret=0

# enable sample daemon
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -e -q > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog
ln -sf %{_libdir}/libfunccddvd-sh-%{version} %{_libdir}/libfunccddvd-sh

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/sample.directory \
#	/usr/share/applications/sample.desktop \
#	/usr/share/applications/sample-admin.desktop

# add a (new) template to bash.bashrc.local
f=/etc/bash.bashrc.local				# pathname of file
templ=%{_datadir}/bash.bashrc.local.add			# template in datadir
tmpf=/tmp/bash.bashrc.local				# tempfile
flag=ksm-open-cd-dvd					# flag for entries
if [ -e $f ]; then					# file exist
	grep -q $flag $f				# look for flag
	ret=$?
	if [ $ret -ne 0 ]; then				# no flag found
		cat $templ >> $f			# add entries
	else						# flag found
		cat $f | grep $flag > $tmpf		# get add from file
		cmp -s $tmpf $templ			# cmp add vs. templ
		ret=$?
		if [ $ret -ne 0 ]; then			# templ is new
			cat $f | grep -v $flag > $tmpf	# rm add from file
			cp $tmpf $f
			cat $templ >> $f		# add new entries
		fi
		rm -f $tmpf
	fi
else
	echo "File $f not found!"
fi

if [ "$1" == 1 ]; then					# install package
	echo "Configure $cf"
#	echo "Users must create HOME/.samplerc with update-sample"
else							# upgrade package
	# update global conf
	if [ -e $cf.rpmsave ]; then
		#cp $cf $cf.rpmnew
		. $cf
		. $cf.rpmsave

		# update conf vars START -------------------------------------
		if [ -x %{_bindir}/replcnfvar ]; then
			for c in $cnfvars; do
				t="\$$c"
				eval s="$t"
				s=\"$s\"
				%{_bindir}/replcnfvar $cf $c "$s"
			done
		else
			echo "Error - cmd replcnfvar not found or not executable!" >&2
			echo "Conf file not updated!" >&2
		fi
		# update conf vars STOP --------------------------------------

#		# update array vars START ------------------------------------
#		# array var MainArr
#		cnt=${#MainArr[@]}			# max index of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
#			while [ "$i" -lt $cnt ]; do
#				let i++
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi
#		# update array vars STOP -------------------------------------

		# compare new conf vars <--> old conf vars
		diff $cf $cf.rpmsave > /dev/null 2>&1
		ret=$?
		if [ "$ret" -eq 0 ]; then
			rm $cf.rpmsave
		else
			echo "Check $cf"
		fi
	fi

#	echo "If new version then users must update HOME/.samplerc with update-sample"
fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	# backup config files
	test -e %{_confdir}/cd-dvd.conf && cp %{_confdir}/cd-dvd.conf %{_confdir}/cd-dvd.conf.rpmsave
	#test -e %{_scnfdir}/cd-dvd && cp %{_scnfdir}/cd-dvd %{_scnfdir}/cd-dvd.rpmsave

	# disable sample daemon and stop sampledm
	#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	rm -f %{_libdir}/libfunccddvd-sh

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/sample.directory \
	#	/usr/share/applications/sample.desktop \
	#	/usr/share/applications/sample-admin.desktop

	# remove entries from file bash.bashrc.local
	f=/etc/bash.bashrc.local			# pathname of file
	tmpf=/tmp/bash.bashrc.local			# tempfile
	flag=ksm-open-cd-dvd				# flag for entries
	ret=0
	if [ -e $f ]; then
		grep -q $flag $f			# look for flag
		ret=$?
		if [ $ret -eq 0 ]; then			# flag found
			cat $f | grep -v $flag > $tmpf	# rm add from file
			cp $tmpf $f
			rm -f $tmpf
		fi
	else
		echo "File $f not found!"
	fi
#else							# upgrade package
fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/ksm-open-cd-dvd
#else							# upgrade package
fi
exit 0

%changelog
* Sun Feb 06 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.4-3.1.0
- makedvd has been revised/improved
  (fixed errmsg).

* Thu Jan 06 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.4-3.0.0
- Update to the libfuncstd-sh 4.0.0

* Thu Nov 04 2021 Repomaster <repomaster@kaesmann-online.de> 1.0.4-2.1.0
- All programs have been revised/improved
  (now we use programs from following packages:
   cdda2wav, cdrecord, mkisofs).

* Thu Nov 04 2021 Repomaster <repomaster@kaesmann-online.de> 1.0.4-2.0.0
- Added 'cd2mp3' from package ksm-multimedia

* Mon Dec 14 2020 Repomaster <repomaster@kaesmann-online.de> 1.0.4-1.0.0
- alias get-cddb will be installed in /etc/bash.bashrc.local

* Fri Dec 04 2020 Repomaster <repomaster@kaesmann-online.de> 1.0.4-0.1.0
- ripcdda2wav has been revised/improved.

* Sun Nov 29 2020 Repomaster <repomaster@kaesmann-online.de> 1.0.4-0.0.0
- The library has been revised/improved
  (added the variable _DEBUG_).
- The manpages have been rebuild.

* Wed Sep 16 2020 Repomaster <repomaster@kaesmann-online.de> 1.0.3-0.0.0
- All programs have been revised/improved.

* Sun Oct 07 2018 Repomaster <repomaster@kaesmann-online.de> 1.0.2-0.1.1
- The library libfunccddvd-sh has been revised/improved
  (fixed output with respect to the IEC)

* Sun Jun 24 2018 Repomaster <repomaster@kaesmann-online.de> 1.0.2-0.1.0
- The library libfunccddvd-sh has been revised
  (fixed minor errors).
- makecd has been revised
  (added function -C, auto scan with function -c).

* Tue Feb 07 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.2-0.0.0
- The library libfunccddvd-sh has been revised. The
  variable Image_Size has been moved to _Image_Size_
- All scripts have been revised
  (using function GetOpt and adopting to the new lib).

* Thu Jan 05 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.1-1.1.0
- All scripts have been revised.

* Thu Oct 16 2014 Repomaster <repomaster@kaesmann-online.de> 1.0.1-1.0.1
- The docu of the package has been revised.

* Fri Sep 28 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-1.0.0
- The package has been revised.
- The script rep-dvdimg has been removed.

* Thu Apr 26 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.1.0
- The config update process has been revised.

* Fri Apr 20 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.0.0
- The name func-cddvd.sh has changed to libfunccddvd-sh.
- Additional to the old link (func-cddvd.sh@) the new link 
  (libfunccddvd-sh@) has introduced. Now only this new link
  should used.
- The var Lib_func_cddvd_sh_Version has removed from the lib.
- The RPM scriptlets are revised.

* Wed Apr 04 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.1.0
- The script rep-dvdimg and the README are revised.

* Tue Apr 03 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.0.2
- The release naming scheme has changed ('.ksm' is removed).

* Tue Jan 04 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.0.2.ksm
- The package name has changed to avoid conflicts with the openSUSE
  distribution. It has been prepended with 'ksm-'.

* Wed Jun 09 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.0.2.ksm
- The package is revised.

* Tue Feb 02 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.0.1.ksm
- Read version and dependency infos from external files.

* Fri Jan 29 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.0.0.ksm
- Script rep-dvdimg has moved from package multimedia to open-cd-dvd.
- The RPM scriptlets are corrected.

* Wed Jan 27 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.0.3.ksm
- The docu has changed.

* Thu Jan 14 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.0.2.ksm
- Some man pages are corrected.

* Thu Nov 19 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.ksm.0.1
- The RPM scriptlets are corrected.

* Mon Oct 26 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.0
- The Package management has changed to RPM.
